<ion-header>
  <ion-toolbar>
    <ion-buttons slot="start">
      <ion-button (click)="navigateBack()">
        <ion-icon slot="icon-only" name="arrow-back"></ion-icon>
      </ion-button>
    </ion-buttons>
    <ion-title *ngIf="calledFrom === 'add'">Add Sales Invoice</ion-title>
    <ion-title *ngIf="calledFrom === 'edit'">Update Sales Invoice</ion-title>
  </ion-toolbar>
</ion-header>

<ion-content class="page-background">
  <ion-fab
    class="ion-margin-end"
    slot="fixed"
    vertical="top"
    color="light"
    horizontal="end"
  >
    <ion-fab-button
      *ngIf="calledFrom === 'add'"
      class="fab-position"
      (click)="submitDraft()"
    >
      <ion-icon name="add"></ion-icon>
    </ion-fab-button>
    <ion-fab-button
      *ngIf="calledFrom === 'edit'"
      class="fab-position"
      (click)="updateSalesInvoice()"
    >
      <ion-icon name="create"></ion-icon>
    </ion-fab-button>
  </ion-fab>
  <ion-grid class="ion-no-padding">
    <ion-row class="ion-no-padding">
      <ion-col class="ion-no-padding">
        <ion-card>
          <ion-card-header>
            <ion-card-title>
              <ion-text color="tertiary">
                Details
              </ion-text>
            </ion-card-title>
          </ion-card-header>
          <ion-card-content>
            <ion-grid class="ion-no-padding">
              <ion-row class="align">
                <ion-col>
                  <!-- <ion-item lines="none">
                    <ion-label position="floating">Naming Series</ion-label>
                    <ion-input
                      readonly="true"
                      type="string"
                      value="SINV-####"
                    ></ion-input>
                  </ion-item> -->
                  <mat-form-field class="example-full-width">
                    <input
                      matInput
                      placeholder="Naming Series"
                      readonly
                      value="SINV-####"
                    />
                  </mat-form-field>
                </ion-col>
                <ion-col>
                  <mat-form-field class="example-full-width">
                    <input
                      matInput
                      placeholder="Company"
                      readonly
                      [formControl]="companyFormControl"
                    />
                  </mat-form-field>
                </ion-col>
              </ion-row>
              <ion-row class="align">
                <ion-col>
                  <mat-form-field class="example-full-width">
                    <input
                      type="text"
                      placeholder="Select Customer"
                      matInput
                      [formControl]="customerFormControl"
                      [matAutocomplete]="auto"
                    />
                    <mat-autocomplete
                      autoActiveFirstOption
                      #auto="matAutocomplete"
                      [displayWith]="getOptionText"
                    >
                      <mat-option
                        *ngFor="let option of filteredCustomerList | async"
                        [value]="option"
                      >
                        {{ option.customer_name }}
                      </mat-option>
                    </mat-autocomplete>
                  </mat-form-field>
                  <!-- <ion-item>
                    <ion-label position="floating">Customer Name</ion-label>
                    <ion-select
                      interface="popover"
                      placeholder="Select Customer"
                      [(ngModel)]="customer"
                    >
                      <ion-select-option
                        [value]="customer"
                        *ngFor="let customer of customerList"
                        >{{customer.name}}</ion-select-option
                      >
                    </ion-select>
                  </ion-item> -->
                </ion-col>
                <ion-col>
                  <!-- <ion-item>
                    <ion-label position="floating">Posting Date</ion-label>
                    <ion-datetime
                      display-format="DD.MM.YYYY"
                      (ionChange)="postingDate($event)"
                    ></ion-datetime>
                  </ion-item> -->
                  <mat-form-field class="example-full-width">
                    <input
                      matInput
                      [matDatepicker]="postingDate"
                      placeholder="Posting Date"
                      readonly
                      [formControl]="postingDateFormControl"
                      (dateChange)="selectedPostingDate($event)"
                    />
                    <mat-datepicker-toggle
                      matSuffix
                      [for]="postingDate"
                    ></mat-datepicker-toggle>
                    <mat-datepicker
                      #postingDate
                      disabled="false"
                    ></mat-datepicker>
                  </mat-form-field>
                </ion-col>
              </ion-row>
              <ion-row class="align">
                <ion-col>
                  <ion-item lines="none">
                    <ion-label>Campaign Invoice</ion-label>
                    <ion-checkbox slot="start"></ion-checkbox>
                  </ion-item>
                </ion-col>
                <ion-col>
                  <mat-form-field class="example-full-width">
                    <input
                      matInput
                      [matDatepicker]="dueDate"
                      placeholder="Due Date"
                      readonly
                      [formControl]="dueDateFormControl"
                      (dateChange)="selectedDueDate($event)"
                    />
                    <mat-datepicker-toggle
                      matSuffix
                      [for]="dueDate"
                    ></mat-datepicker-toggle>
                    <mat-datepicker #dueDate disabled="false"></mat-datepicker>
                  </mat-form-field>
                </ion-col>
              </ion-row>
            </ion-grid>
          </ion-card-content>
        </ion-card>
      </ion-col>
    </ion-row>
    <ion-row class="ion-no-padding">
      <ion-col class="ion-no-padding">
        <ion-card>
          <ion-card-header>
            <ion-row class="align">
              <ion-col>
                <ion-card-title>
                  <ion-text color="tertiary">
                    Items
                  </ion-text>
                </ion-card-title>
              </ion-col>
              <ion-col class="ion-text-right" size="auto">
                <ion-button color="tertiary" fill="outline" (click)="addItem()">
                  Add
                </ion-button>
              </ion-col>
            </ion-row>
          </ion-card-header>
          <ion-card-content class="ion-no-padding">
            <ion-item lines="none">
              <mat-table #table [dataSource]="dataSource" style="width: 100%;">
                <ng-container matColumnDef="item">
                  <mat-header-cell *matHeaderCellDef>Item</mat-header-cell>
                  <mat-cell
                    *matCellDef="let row"
                    [satPopoverAnchor]="p"
                    tabindex="0"
                    (keyup.enter)="p.open()"
                    (click)="p.open()"
                  >
                    <ng-container *ngIf="row.item_name">
                      {{row.item_name}}
                    </ng-container>
                    <span class="add-comment" *ngIf="!row.item_name">
                      Add an item
                    </span>
                    <sat-popover
                      #p
                      hasBackdrop
                      xAlign="start"
                      yAlign="start"
                      (closed)="updateItem(row, $event)"
                    >
                      <inline-edit
                        [value]="row.item_name"
                        column="item"
                      ></inline-edit>
                    </sat-popover>
                  </mat-cell>
                  <mat-footer-cell *matFooterCellDef> </mat-footer-cell>
                </ng-container>
                <ng-container matColumnDef="quantity">
                  <mat-header-cell *matHeaderCellDef>Quantity</mat-header-cell>
                  <mat-cell
                    *matCellDef="let row"
                    [satPopoverAnchor]="p"
                    tabindex="0"
                    (keyup.enter)="p.open()"
                    (click)="p.open()"
                  >
                    <ng-container>
                      {{row.qty}}
                    </ng-container>

                    <sat-popover
                      #p
                      hasBackdrop
                      xAlign="start"
                      yAlign="start"
                      (closed)="updateQuantity(row, $event)"
                    >
                      <inline-edit
                        [value]="row.qty"
                        column="quantity"
                      ></inline-edit>
                    </sat-popover>
                  </mat-cell>
                  <mat-footer-cell *matFooterCellDef> </mat-footer-cell>
                </ng-container>
                <ng-container matColumnDef="rate">
                  <mat-header-cell *matHeaderCellDef>Rate</mat-header-cell>
                  <mat-cell
                    *matCellDef="let row"
                    [satPopoverAnchor]="p"
                    tabindex="0"
                    (keyup.enter)="p.open()"
                    (click)="p.open()"
                  >
                    <ng-container>
                      {{row.rate}}
                    </ng-container>
                    <sat-popover
                      #p
                      hasBackdrop
                      xAlign="start"
                      yAlign="start"
                      (closed)="updateRate(row, $event)"
                    >
                      <inline-edit
                        [value]="row.rate"
                        column="rate"
                      ></inline-edit>
                    </sat-popover>
                  </mat-cell>
                  <mat-footer-cell *matFooterCellDef>Total </mat-footer-cell>
                </ng-container>
                <ng-container matColumnDef="total">
                  <mat-header-cell *matHeaderCellDef>Total</mat-header-cell>
                  <mat-cell *matCellDef="let row"
                    >{{row.rate * row.qty}}</mat-cell
                  >
                  <mat-footer-cell *matFooterCellDef>{{total}}</mat-footer-cell>
                </ng-container>
                <ng-container matColumnDef="delete">
                  <mat-header-cell *matHeaderCellDef></mat-header-cell>
                  <mat-cell *matCellDef="let row ; let i = index">
                    <ion-button
                      (click)="deleteRow(i)"
                      fill="clear"
                      class="ion-no-padding"
                    >
                      <ion-icon slot="icon-only" name="trash"></ion-icon>
                    </ion-button>
                  </mat-cell>
                  <mat-footer-cell *matFooterCellDef></mat-footer-cell>
                </ng-container>
                <mat-header-row
                  *matHeaderRowDef="displayedColumns; sticky: true"
                ></mat-header-row>
                <mat-row
                  *matRowDef="let row; columns: displayedColumns;"
                ></mat-row>
                <mat-footer-row
                  class="footer"
                  *matFooterRowDef="displayedColumns; sticky: true"
                ></mat-footer-row>
              </mat-table>
            </ion-item>
          </ion-card-content>
        </ion-card>
      </ion-col>
    </ion-row>
    <ion-row class="ion-no-padding">
      <ion-col class="ion-no-padding">
        <ion-card>
          <ion-card-header>
            <ion-card-title>
              <ion-text color="tertiary">
                Address
              </ion-text>
            </ion-card-title>
          </ion-card-header>
          <!-- <ion-card-content *ngIf="customer.name !== '' ">
            <ion-grid class="ion-no-padding">
              <ion-row>
                <ion-col>
                  <ion-item lines="none">
                    <ion-label position="stacked">Customer address</ion-label>
                    {{customer.addressLine1}}
                    <br />
                    {{customer.addressLine2}}
                    <br />
                    {{customer.city}} - {{customer.pinCode}}
                  </ion-item>
                </ion-col>
                <ion-col>
                  <ion-item lines="none">
                    <ion-label position="stacked">Contact Person</ion-label>
                    {{customer.name}}
                  </ion-item>
                </ion-col>
              </ion-row>
            </ion-grid>
          </ion-card-content> -->
        </ion-card>
      </ion-col>
    </ion-row>
  </ion-grid>
</ion-content>
